import { v1 as uuidv1 } from 'uuid'
export default {
  data() {
    return {
      elId: '',
      outBoxDom: null,
      jsoneditorVisible: false
    }
  },
  created() {
    this.initElid()
  },
  mounted() {
    this.initElid()
    setTimeout(() => {
      this.showEditJsonDialog()
    }, 2000)
  },
  destroyed() {
    if (this.outBoxDom) {
      this.outBoxDom.removeEventListener('mousedown', this.boxEventMouse)
      this.outBoxDom = null
    }
    this.chart = null
  },
  beforeDestroy() {
    clearInterval(this.timer)// 清除定时器
    this.timer = null
    if (this.chart) {
      this.chart.clear()
      this.chart.dispose()
      this.chart = null
    }
  },
  methods: {
    showJsonEditDialog() {
      this.jsoneditorVisible = true
    },
    initElid() {
      if (!this.elId) {
        this.elId = uuidv1() // 获取随机id
      }
    },
    getIsDev() {
      const user_info = sessionStorage['user_info']
      if (user_info) {
        const user_info_json = JSON.parse(user_info)
        const { systemSysDevDb } = user_info_json
        if (
          systemSysDevDb === true ||
          systemSysDevDb === '1' ||
          systemSysDevDb === 1
        ) { return true }
      } else {
        // 这是在本地开发时使用没有user_info时
        const hostname=location.hostname
        if (top === self && (hostname === '0.0.0.0'||hostname==='localhost')) return true
        if (top !== self && (hostname !== '0.0.0.0'||hostname !== 'localhost')) return false

      }
    },
    boxEventMouse(event) {
      const that = this
      event.stopPropagation()
      const isDev = this.getIsDev()
      if (!isDev) return
      if (event.shiftKey && event.altKey && !event.ctrlKey) {
        that.showJsonEditDialog()
      }
    },
    // 弹出可编辑的弹框
    showEditJsonDialog() {
      this.outBoxDom = document.getElementById(this.elId)
      this.outBoxDom && this.outBoxDom.addEventListener('mousedown', this.boxEventMouse)
    }

  }
}
